<?php

/*

c64img version 310307-01
Copyright (C) 2007  Johan Fitie <johan@johanfitie.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


Use the following options:
 image=[filename.png|gif|jpg]
                    select image file to convert
 size=double        double the size of the output image
 show=c64           only show the c64 image
 dither=[0-100]     dither percentage (default: 50%)
 palette=[c64s|ccs64|frodo|godot|pc64|vice|pepto]
                    select palette

*/


// Commodore 64 palette
$c64r=array(0x00,0xff,0x88,0x68,0xa8,0x50,0x18,0xf0,0xa0,0x47,0xc8,0x48,0x80,0x98,0x50,0xb8);
$c64g=array(0x00,0xff,0x20,0xd0,0x38,0xb8,0x10,0xe8,0x48,0x2b,0x78,0x48,0x80,0xff,0x90,0xb8);
$c64b=array(0x00,0xff,0x00,0xa8,0xa0,0x18,0x90,0x58,0x00,0x1b,0x70,0x48,0x80,0x98,0xd0,0xb8);

if (isset($_GET['palette'])&&$_GET['palette']=="c64s") {
 $c64r=array(0x00,0xfc,0xa8,0x54,0xa8,0x00,0x00,0xfc,0xa8,0x80,0xfc,0x54,0x80,0x54,0x54,0xa8);
 $c64g=array(0x00,0xfc,0x00,0xfc,0x00,0xa8,0x00,0xfc,0x54,0x2c,0x54,0x54,0x80,0xfc,0x54,0xa8);
 $c64b=array(0x00,0xfc,0x00,0xfc,0xa8,0x00,0xa8,0x00,0x00,0x00,0x54,0x54,0x80,0x54,0xfc,0xa8);
}

if (isset($_GET['palette'])&&$_GET['palette']=="ccs64") {
 $c64r=array(0x10,0xff,0xe0,0x60,0xe0,0x40,0x40,0xff,0xe0,0x9c,0xff,0x54,0x88,0xa0,0xa0,0xc0);
 $c64g=array(0x10,0xff,0x40,0xff,0x60,0xe0,0x40,0xff,0xa0,0x74,0xa0,0x54,0x88,0xff,0xa0,0xc0);
 $c64b=array(0x10,0xff,0x40,0xff,0xe0,0x40,0xe0,0x40,0x40,0x48,0xa0,0x54,0x88,0xa0,0xff,0xc0);
}

if (isset($_GET['palette'])&&$_GET['palette']=="frodo") {
 $c64r=array(0x00,0xff,0xcc,0x00,0xff,0x00,0x00,0xff,0xff,0x88,0xff,0x44,0x88,0x88,0x88,0xcc);
 $c64g=array(0x00,0xff,0x00,0xff,0x00,0xcc,0x00,0xff,0x88,0x44,0x88,0x44,0x88,0xff,0x88,0xcc);
 $c64b=array(0x00,0xff,0x00,0xcc,0xff,0x00,0xcc,0x00,0x00,0x00,0x88,0x44,0x88,0x88,0xff,0xcc);
}

if (isset($_GET['palette'])&&$_GET['palette']=="godot") {
 $c64r=array(0x00,0xff,0x88,0xaa,0xcc,0x00,0x00,0xee,0xdd,0x66,0xfe,0x33,0x77,0xaa,0x00,0xbb);
 $c64g=array(0x00,0xff,0x00,0xff,0x44,0xcc,0x00,0xee,0x88,0x44,0x77,0x33,0x77,0xff,0x88,0xbb);
 $c64b=array(0x00,0xff,0x00,0xee,0xcc,0x55,0xaa,0x77,0x55,0x00,0x77,0x33,0x77,0x66,0xff,0xbb);
}

if (isset($_GET['palette'])&&$_GET['palette']=="pc64") {
 $c64r=array(0x21,0xff,0xb5,0x73,0xb5,0x21,0x21,0xff,0xb5,0x94,0xff,0x73,0x94,0x73,0x73,0xb5);
 $c64g=array(0x21,0xff,0x21,0xff,0x21,0xb5,0x21,0xff,0x73,0x42,0x73,0x73,0x94,0xff,0x73,0xb5);
 $c64b=array(0x21,0xff,0x21,0xff,0xb5,0x21,0xb5,0x21,0x21,0x21,0x73,0x73,0x94,0x73,0xff,0xb5);
}

if (isset($_GET['palette'])&&$_GET['palette']=="vice") {
 $c64r=array(0x00,0xfd,0xbe,0x30,0xb4,0x1f,0x21,0xdf,0xb8,0x6a,0xfe,0x42,0x70,0x59,0x5f,0xa4);
 $c64g=array(0x00,0xfe,0x1a,0xe6,0x1a,0xd2,0x1b,0xf6,0x41,0x33,0x4a,0x45,0x74,0xfe,0x53,0xa7);
 $c64b=array(0x00,0xfc,0x24,0xc6,0xe2,0x1e,0xae,0x0a,0x04,0x04,0x57,0x40,0x6f,0x59,0xfe,0xa2);
}

if (isset($_GET['palette'])&&$_GET['palette']=="pepto") { // http://www.pepto.de/projects/colorvic/
 $c64r=array(0x00,0xff,0x68,0x70,0x6f,0x58,0x35,0xb8,0x6f,0x43,0x9a,0x44,0x6c,0x9a,0x6c,0x95);
 $c64g=array(0x00,0xff,0x37,0xa4,0x3d,0x8d,0x28,0xc7,0x4f,0x39,0x67,0x44,0x6c,0xd2,0x5e,0x95);
 $c64b=array(0x00,0xff,0x2b,0xb2,0x86,0x43,0x79,0x6f,0x25,0x00,0x59,0x44,0x6c,0x84,0xb5,0x95);
}

// Get dither percentage
$dither=50;
if (isset($_GET['dither'])&&(int)$_GET['dither']>=0&&(int)$_GET['dither']<=100) {$dither=(int)$_GET['dither'];}

// Get and open (or create) image
if (isset($_GET['image'])) {$filename=$_GET['image'];} else {$filename="";}
if (eregi("\.png",$filename)) {$image=imagecreatefrompng($filename);}
if (eregi("\.gif",$filename)) {$image=imagecreatefromgif($filename);}
if (eregi("\.jpg",$filename)||eregi("\.jpeg",$filename)) {$image=imagecreatefromjpeg($filename);}
if (!$image) {$image=imagecreatetruecolor(320,200);}

// Resample original and make room for C64 image
$imgwidth=320;$imgheight=$imgwidth/(imagesx($image)/imagesy($image));
if ($imgheight>200) {$imgheight=200;$imgwidth=$imgheight*(imagesx($image)/imagesy($image));}
$c64image=imagecreatetruecolor(640,200);
imagecopyresampled($c64image,$image,(320-$imgwidth)/2,(200-$imgheight)/2,0,0,$imgwidth,$imgheight,imagesx($image),imagesy($image));

// Find closest C64 color
for ($y=0;$y<200;$y++) {
 for ($x=0;$x<160;$x++) {

  // Get pixel color and add Floyd-Steinberg distribution
  $pixel1=imagecolorat($c64image,$x*2,$y);
  $pixel2=imagecolorat($c64image,$x*2+1,$y);
  $r=$fsr[$x][$y%3]+((($pixel1>>16)&0xFF)+(($pixel2>>16)&0xFF))/2;
  $g=$fsg[$x][$y%3]+((($pixel1>>8)&0xFF)+(($pixel2>>8)&0xFF))/2;
  $b=$fsb[$x][$y%3]+(($pixel1&0xFF)+($pixel2&0xFF))/2;

  // Scan for closest color
  for ($i=0;$i<16;$i++) {
   $difft=abs(($c64r[$i]-$r)/.771)+abs(($c64g[$i]-$g)/.413)+abs(($c64b[$i]-$b)/.886);
   if ($i==0||$difft<$bestdifft) {$bestcolor=$i;$bestdifft=$difft;}
  }

  // What remains to be distributed?
  $errorr=($r-$c64r[$bestcolor])/16*($dither/100);
  $errorg=($g-$c64g[$bestcolor])/16*($dither/100);
  $errorb=($b-$c64b[$bestcolor])/16*($dither/100);

  // Floyd-Steinberg dither (keep 3 lines in memory, work on 2 while clearing the 3rd)
  $fsr[$x+1][($y+0)%3]+=$errorr*7; $fsg[$x+1][($y+0)%3]+=$errorg*7; $fsb[$x+1][($y+0)%3]+=$errorb*7;
  $fsr[$x-1][($y+1)%3]+=$errorr*3; $fsg[$x-1][($y+1)%3]+=$errorg*3; $fsb[$x-1][($y+1)%3]+=$errorb*3;
  $fsr[$x+0][($y+1)%3]+=$errorr*5; $fsg[$x+0][($y+1)%3]+=$errorg*5; $fsb[$x+0][($y+1)%3]+=$errorb*5;
  $fsr[$x+1][($y+1)%3]+=$errorr*1; $fsg[$x+1][($y+1)%3]+=$errorg*1; $fsb[$x+1][($y+1)%3]+=$errorb*1;
  $fsr[$x+0][($y+2)%3] =0;         $fsg[$x+0][($y+2)%3] =0;         $fsb[$x+0][($y+2)%3] =0;

  // Draw color
  $color=imagecolorallocate($c64image,$c64r[$bestcolor],$c64g[$bestcolor],$c64b[$bestcolor]);
  imageline($c64image,$x*2+320,$y,$x*2+321,$y,$color);

 }
}

// Only show rendered c64 image if requested
if (isset($_GET['show'])&&$_GET['show']=="c64") {
 $buffer=imagecreatetruecolor(imagesx($c64image)/2,imagesy($c64image));
 imagecopy($buffer,$c64image,0,0,imagesx($c64image)/2,0,imagesx($buffer),imagesy($buffer));
 imagedestroy($c64image);
 $c64image=imagecreatetruecolor(imagesx($buffer),imagesy($buffer));
 imagecopyresized($c64image,$buffer,0,0,0,0,imagesx($c64image),imagesy($c64image),imagesx($buffer),imagesy($buffer));
 imagedestroy($buffer);
}

// Resize to double size if requested
if (isset($_GET['size'])&&$_GET['size']=="double") {
 $buffer=imagecreatetruecolor(imagesx($c64image)*2,imagesy($c64image)*2);
 imagecopyresized($buffer,$c64image,0,0,0,0,imagesx($buffer),imagesy($buffer),imagesx($c64image),imagesy($c64image));
 imagedestroy($c64image);
 $c64image=imagecreatetruecolor(imagesx($buffer),imagesy($buffer));
 imagecopyresized($c64image,$buffer,0,0,0,0,imagesx($c64image),imagesy($c64image),imagesx($buffer),imagesy($buffer));
 imagedestroy($buffer);
}

// Output as PNG
header('Content-Type: image/png');
imagepng($c64image);

// Destroy images
imagedestroy($image);
imagedestroy($c64image);

?> 
